import _objectWithoutProperties from "babel-runtime/helpers/objectWithoutProperties";
import _Object$assign from "babel-runtime/core-js/object/assign";
import _Object$keys from "babel-runtime/core-js/object/keys";
import _extends from "babel-runtime/helpers/extends";
import _typeof from "babel-runtime/helpers/typeof";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
import { PureComponent } from "react";
import PropTypes from "prop-types";
import axios from "axios";
import _debounce from "lodash.debounce";
import _isPlainObject from "lodash.isplainobject";
import _isEqual from "fast-deep-equal";
import { isEvent, serialize, concatParams, parseMime } from "./utils";

var defaultFetchCreator = function defaultFetchCreator(requestData) {
  return axios(requestData);
};
var boolEval = function boolEval(be) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return !!(typeof be === "function" ? be.apply(undefined, args) : be);
};

var AsyncFetcher = function (_PureComponent) {
  _inherits(AsyncFetcher, _PureComponent);

  function AsyncFetcher(props) {
    _classCallCheck(this, AsyncFetcher);

    var _this = _possibleConstructorReturn(this, _PureComponent.call(this, props));

    _this.setCustomState = function (state) {
      if (!!state && ((typeof state === "undefined" ? "undefined" : _typeof(state)) === "object" || typeof state === "function")) {
        var hasCustom = false;
        var customState = _this.state.customState;

        if (typeof state === "function") {
          state = state(_extends({
            params: _this.state.params,
            postData: _this.state.postData
          }, customState));
          if ((typeof state === "undefined" ? "undefined" : _typeof(state)) !== "object") {
            return;
          }
        }

        _Object$keys(state).forEach(function (k) {
          if (["params", "postData", "data"].indexOf(k) !== -1) {
            if (!_isEqual(_this.state[k], state[k])) {
              var _this$setState;

              _this.setState((_this$setState = {}, _this$setState[k] = state[k], _this$setState));
            }
          } else {
            customState[k] = state[k];
            hasCustom = true;
          }
        });

        if (hasCustom) {
          _this.setState({ customState: customState }, function () {
            return _this.forceUpdate();
          });
        }
      }
    };

    _this.getState = function () {
      var baseState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _baseState$params = baseState.params,
          params = _baseState$params === undefined ? null : _baseState$params,
          _baseState$postData = baseState.postData,
          postData = _baseState$postData === undefined ? null : _baseState$postData,
          _baseState$state = baseState.state,
          state = _baseState$state === undefined ? null : _baseState$state;


      if (!params) {
        params = concatParams(_this.props.params, _this.state.params);
      }
      if (!postData) {
        postData = concatParams(_this.props.postData, _this.state.postData);
      }
      if (!state) {
        state = _this.state.customState;
      }

      return {
        params: params,
        postData: postData,
        state: state
      };
    };

    _this.fetch = function () {
      var dataEvent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var axiosConfig = _this.props.axiosConfig || {};

      var method = _this.props.method.toLowerCase();
      var isPost = method === "post" || method === "put";
      var isEventData = !!dataEvent && isEvent(dataEvent);

      var customState = {};
      if (!isEventData && _isPlainObject(dataEvent)) {
        axiosConfig = _Object$assign(axiosConfig, function () {
          var params = dataEvent.params,
              postData = dataEvent.postData,
              axiosConfig = _objectWithoutProperties(dataEvent, ["params", "postData"]);

          if (!!params) {
            customState.params = dataEvent.params;
          }
          if (isPost && !!postData) {
            customState.postData = dataEvent.postData;
          }
          return axiosConfig;
        }());
      }

      var state = _this.getState(customState);
      var params = state.params,
          postData = state.postData;


      if (isEventData && boolEval(_this.props.autoPreventDefault, state) && dataEvent.preventDefault) {
        dataEvent.preventDefault();
      }

      if (!boolEval(_this.props.canFetch, state)) {
        return;
      }

      var _this$props$axiosConf = _extends({}, _this.props, axiosConfig),
          url = _this$props$axiosConf.url,
          headers = _this$props$axiosConf.headers,
          authToken = _this$props$axiosConf.authToken,
          ajax = _this$props$axiosConf.ajax,
          accepts = _this$props$axiosConf.accepts,
          responseType = _this$props$axiosConf.responseType,
          withCredentials = _this$props$axiosConf.withCredentials,
          transformError = _this$props$axiosConf.transformError,
          fetchCreator = _this$props$axiosConf.fetchCreator,
          onResponse = _this$props$axiosConf.onResponse,
          onError = _this$props$axiosConf.onError;

      var contentType = !!_this.props.contentType ? parseMime(_this.props.contentType) : isPost ? parseMime("form") : null;

      var customHeaders = {};
      if (!!contentType) {
        customHeaders["Content-Type"] = contentType;
      }
      if (!!authToken) {
        var authorization = typeof authToken === "function" ? authToken() : authToken;
        if (!!authorization) {
          if (authorization.indexOf("Bearer") === -1) {
            authorization = "Bearer " + authorization;
          }
          customHeaders["Authorization"] = authorization;
        }
      }
      if (!!ajax) {
        customHeaders["X-Requested-With"] = "XMLHttpRequest";
      }
      if (!!accepts) {
        customHeaders["Accept"] = function () {
          if (typeof accepts === "string") {
            return accepts.split(";").map(parseMime).join(";");
          }
          if (Array.isArray(accepts)) {
            return accepts.map(parseMime).join(";");
          }
          if (typeof accepts === "function") {
            return accepts();
          }
          return accepts;
        }();
      }

      var requestConfig = {
        method: method,
        withCredentials: !!withCredentials,
        headers: _extends({}, headers, customHeaders)
      };

      if (typeof url === "function") {
        requestConfig.url = url(state);
      } else {
        requestConfig.url = url;

        if (!!params) {
          if (typeof params !== "string" && _isPlainObject(params)) {
            params = serialize(params);
          }
          if (typeof params === "string") {
            requestConfig.url = (requestConfig.url + (requestConfig.url.indexOf("?") === -1 ? "?" : "&") + params).replace(/\?&/gi, "?");
          } else {
            requestConfig.params = params;
          }
        }
      }

      if (isPost) {
        if (!!postData && contentType.indexOf("x-www-form-urlencoded") !== -1 && _isPlainObject(postData)) {
          postData = serialize(postData);
        }
        requestConfig.data = postData;
      }

      if (!!responseType) {
        requestConfig.responseType = responseType;
      }

      _this.setState({ isLoading: true, error: null }, function () {
        return fetchCreator(_extends({}, requestConfig, axiosConfig)).then(function (response) {
          if (!_this._mounted) {
            return;
          }

          _this.setState({
            response: response,
            data: response.data,
            isLoading: false
          }, function () {
            if (!!onResponse) onResponse({
              isLoading: false,
              response: _this.state.response,
              data: _this.state.data,
              set: _this.setCustomState,
              params: params,
              postData: !!isPost ? postData : null,
              state: _this.state.customState,
              error: null
            });
          });
        }).catch(function (error) {
          if (!_this._mounted) {
            return;
          }

          var transformedError = transformError(_extends({}, error));

          _this.setState(function () {
            var errorState = {
              error: "" + (!!transformedError && typeof transformedError === "string" ? transformedError : error),
              response: null,
              data: null,
              isLoading: false
            };
            if (!!transformedError && (typeof transformedError === "undefined" ? "undefined" : _typeof(transformedError)) === "object" && "response" in transformedError) {
              errorState.response = transformedError.response;

              if (!!errorState.response && _typeof(errorState.response) === "object" && "data" in errorState.response) {
                errorState.data = errorState.response.data;
              }
            }

            return errorState;
          }, function () {
            if (!!onError) onError(transformedError, {
              isLoading: false,
              response: _this.state.response,
              error: _this.state.error,
              data: _this.state.data,
              set: _this.setCustomState,
              params: params,
              postData: !!isPost ? postData : null,
              state: _this.state.customState
            });
          });
        });
      });
    };

    _this._mounted = false;


    _this._debouncedUpdate = +props.debounce > 0 ? _debounce(_this._update.bind(_this), +props.debounce) : _this._update.bind(_this);

    _this.state = {
      isLoading: !!props.autoFetch,
      response: null,
      data: null,
      error: null,
      params: null,
      postData: null,
      customState: {}
    };
    return _this;
  }

  AsyncFetcher.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    this._debouncedUpdate(prevProps, prevState);
  };

  AsyncFetcher.prototype.componentDidMount = function componentDidMount() {
    this._mounted = true;

    if (!!this.props.autoFetch) {
      this.fetch();
    }
  };

  AsyncFetcher.prototype.componentWillUnmount = function componentWillUnmount() {
    this._mounted = false;
  };

  AsyncFetcher.prototype._update = function _update(prevProps, prevState) {
    var _this2 = this;

    var hasChange = false;
    ["method", "params", "postData", "url", "authToken"].forEach(function (k) {
      if (k in prevProps && !_isEqual(prevProps[k], _this2.props[k])) {
        hasChange = true;
      }
    });
    if (!hasChange) {
      ["params", "postData"].forEach(function (k) {
        if (k in prevState && !_isEqual(prevState[k], _this2.state[k])) {
          hasChange = true;
        }
      });
    }

    if (+prevProps.debounce !== +this.props.debounce) {
      this._debouncedUpdate = +this.props.debounce > 0 ? _debounce(this._update.bind(this), +this.props.debounce) : this._update.bind(this);
    }

    if (hasChange && !!this.props.autoFetch) {
      this.fetch();
    }
  };

  AsyncFetcher.prototype.render = function render() {
    if (!!this.props.children && typeof this.props.children === "function") {
      return this.props.children(_extends({
        fetch: this.fetch,
        isLoading: this.state.isLoading,
        response: this.state.response,
        data: this.state.data,
        error: this.state.error,
        set: this.setCustomState
      }, this.getState())) || null;
    }

    return null;
  };

  return AsyncFetcher;
}(PureComponent);

AsyncFetcher.propTypes = {
  autoFetch: PropTypes.bool,
  autoPreventDefault: PropTypes.oneOfType([PropTypes.bool, PropTypes.func]),
  canFetch: PropTypes.oneOfType([PropTypes.bool, PropTypes.func]),
  method: PropTypes.oneOf(["get", "post", "put", "delete", "options"]),
  url: PropTypes.oneOfType([PropTypes.string, PropTypes.func]).isRequired,
  params: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  postData: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  headers: PropTypes.object,
  axiosConfig: PropTypes.object,
  ajax: PropTypes.bool,
  authToken: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  accepts: PropTypes.oneOfType([PropTypes.string, PropTypes.array, PropTypes.func]),
  contentType: PropTypes.string,
  responseType: PropTypes.string,
  withCredentials: PropTypes.bool,
  transformError: PropTypes.func,
  fetchCreator: PropTypes.func,
  onResponse: PropTypes.func,
  onError: PropTypes.func,
  debounce: PropTypes.number,
  children: PropTypes.func
};
AsyncFetcher.defaultProps = {
  autoFetch: true,
  canFetch: true,
  autoPreventDefault: true,
  method: "get",
  headers: {},
  axiosConfig: {},
  ajax: false,
  withCredentials: false,
  transformError: function transformError(err) {
    return err;
  },
  fetchCreator: defaultFetchCreator,
  debounce: 0
};
export default AsyncFetcher;