(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define("AsyncFetcher", ["exports", "babel-runtime/helpers/objectWithoutProperties", "babel-runtime/core-js/object/assign", "babel-runtime/helpers/defineProperty", "babel-runtime/core-js/object/keys", "babel-runtime/helpers/extends", "babel-runtime/helpers/typeof", "babel-runtime/core-js/object/get-prototype-of", "babel-runtime/helpers/classCallCheck", "babel-runtime/helpers/createClass", "babel-runtime/helpers/possibleConstructorReturn", "babel-runtime/helpers/inherits", "react", "prop-types", "axios", "lodash.debounce", "lodash.isplainobject", "fast-deep-equal", "./utils"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("babel-runtime/helpers/objectWithoutProperties"), require("babel-runtime/core-js/object/assign"), require("babel-runtime/helpers/defineProperty"), require("babel-runtime/core-js/object/keys"), require("babel-runtime/helpers/extends"), require("babel-runtime/helpers/typeof"), require("babel-runtime/core-js/object/get-prototype-of"), require("babel-runtime/helpers/classCallCheck"), require("babel-runtime/helpers/createClass"), require("babel-runtime/helpers/possibleConstructorReturn"), require("babel-runtime/helpers/inherits"), require("react"), require("prop-types"), require("axios"), require("lodash.debounce"), require("lodash.isplainobject"), require("fast-deep-equal"), require("./utils"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.objectWithoutProperties, global.assign, global.defineProperty, global.keys, global._extends, global._typeof, global.getPrototypeOf, global.classCallCheck, global.createClass, global.possibleConstructorReturn, global.inherits, global.react, global.propTypes, global.axios, global.lodash, global.lodash, global.fastDeepEqual, global.utils);
    global.AsyncFetcher = mod.exports;
  }
})(this, function (exports, _objectWithoutProperties2, _assign, _defineProperty2, _keys, _extends2, _typeof2, _getPrototypeOf, _classCallCheck2, _createClass2, _possibleConstructorReturn2, _inherits2, _react, _propTypes, _axios, _lodash, _lodash3, _fastDeepEqual, _utils) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

  var _assign2 = _interopRequireDefault(_assign);

  var _defineProperty3 = _interopRequireDefault(_defineProperty2);

  var _keys2 = _interopRequireDefault(_keys);

  var _extends3 = _interopRequireDefault(_extends2);

  var _typeof3 = _interopRequireDefault(_typeof2);

  var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

  var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

  var _createClass3 = _interopRequireDefault(_createClass2);

  var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

  var _inherits3 = _interopRequireDefault(_inherits2);

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var _axios2 = _interopRequireDefault(_axios);

  var _lodash2 = _interopRequireDefault(_lodash);

  var _lodash4 = _interopRequireDefault(_lodash3);

  var _fastDeepEqual2 = _interopRequireDefault(_fastDeepEqual);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var defaultFetchCreator = function defaultFetchCreator(requestData) {
    return (0, _axios2.default)(requestData);
  };
  var boolEval = function boolEval(be) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return !!(typeof be === "function" ? be.apply(undefined, args) : be);
  };

  var AsyncFetcher = function (_PureComponent) {
    (0, _inherits3.default)(AsyncFetcher, _PureComponent);

    function AsyncFetcher(props) {
      (0, _classCallCheck3.default)(this, AsyncFetcher);

      var _this = (0, _possibleConstructorReturn3.default)(this, (AsyncFetcher.__proto__ || (0, _getPrototypeOf2.default)(AsyncFetcher)).call(this, props));

      _this.setCustomState = function (state) {
        if (!!state && ((typeof state === "undefined" ? "undefined" : (0, _typeof3.default)(state)) === "object" || typeof state === "function")) {
          var hasCustom = false;
          var customState = _this.state.customState;

          if (typeof state === "function") {
            state = state((0, _extends3.default)({
              params: _this.state.params,
              postData: _this.state.postData
            }, customState));
            if ((typeof state === "undefined" ? "undefined" : (0, _typeof3.default)(state)) !== "object") {
              return;
            }
          }

          (0, _keys2.default)(state).forEach(function (k) {
            if (["params", "postData", "data"].indexOf(k) !== -1) {
              if (!(0, _fastDeepEqual2.default)(_this.state[k], state[k])) {
                _this.setState((0, _defineProperty3.default)({}, k, state[k]));
              }
            } else {
              customState[k] = state[k];
              hasCustom = true;
            }
          });

          if (hasCustom) {
            _this.setState({ customState: customState }, function () {
              return _this.forceUpdate();
            });
          }
        }
      };

      _this.getState = function () {
        var baseState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var _baseState$params = baseState.params,
            params = _baseState$params === undefined ? null : _baseState$params,
            _baseState$postData = baseState.postData,
            postData = _baseState$postData === undefined ? null : _baseState$postData,
            _baseState$state = baseState.state,
            state = _baseState$state === undefined ? null : _baseState$state;


        if (!params) {
          params = (0, _utils.concatParams)(_this.props.params, _this.state.params);
        }
        if (!postData) {
          postData = (0, _utils.concatParams)(_this.props.postData, _this.state.postData);
        }
        if (!state) {
          state = _this.state.customState;
        }

        return {
          params: params,
          postData: postData,
          state: state
        };
      };

      _this.fetch = function () {
        var dataEvent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var axiosConfig = _this.props.axiosConfig || {};

        var method = _this.props.method.toLowerCase();
        var isPost = method === "post" || method === "put";
        var isEventData = !!dataEvent && (0, _utils.isEvent)(dataEvent);

        var customState = {};
        if (!isEventData && (0, _lodash4.default)(dataEvent)) {
          axiosConfig = (0, _assign2.default)(axiosConfig, function () {
            var params = dataEvent.params,
                postData = dataEvent.postData,
                axiosConfig = (0, _objectWithoutProperties3.default)(dataEvent, ["params", "postData"]);

            if (!!params) {
              customState.params = dataEvent.params;
            }
            if (isPost && !!postData) {
              customState.postData = dataEvent.postData;
            }
            return axiosConfig;
          }());
        }

        var state = _this.getState(customState);
        var params = state.params,
            postData = state.postData;


        if (isEventData && boolEval(_this.props.autoPreventDefault, state) && dataEvent.preventDefault) {
          dataEvent.preventDefault();
        }

        if (!boolEval(_this.props.canFetch, state)) {
          return;
        }

        var _this$props$axiosConf = (0, _extends3.default)({}, _this.props, axiosConfig),
            url = _this$props$axiosConf.url,
            headers = _this$props$axiosConf.headers,
            authToken = _this$props$axiosConf.authToken,
            ajax = _this$props$axiosConf.ajax,
            accepts = _this$props$axiosConf.accepts,
            responseType = _this$props$axiosConf.responseType,
            withCredentials = _this$props$axiosConf.withCredentials,
            transformError = _this$props$axiosConf.transformError,
            fetchCreator = _this$props$axiosConf.fetchCreator,
            onResponse = _this$props$axiosConf.onResponse,
            onError = _this$props$axiosConf.onError;

        var contentType = !!_this.props.contentType ? (0, _utils.parseMime)(_this.props.contentType) : isPost ? (0, _utils.parseMime)("form") : null;

        var customHeaders = {};
        if (!!contentType) {
          customHeaders["Content-Type"] = contentType;
        }
        if (!!authToken) {
          var authorization = typeof authToken === "function" ? authToken() : authToken;
          if (!!authorization) {
            if (authorization.indexOf("Bearer") === -1) {
              authorization = "Bearer " + authorization;
            }
            customHeaders["Authorization"] = authorization;
          }
        }
        if (!!ajax) {
          customHeaders["X-Requested-With"] = "XMLHttpRequest";
        }
        if (!!accepts) {
          customHeaders["Accept"] = function () {
            if (typeof accepts === "string") {
              return accepts.split(";").map(_utils.parseMime).join(";");
            }
            if (Array.isArray(accepts)) {
              return accepts.map(_utils.parseMime).join(";");
            }
            if (typeof accepts === "function") {
              return accepts();
            }
            return accepts;
          }();
        }

        var requestConfig = {
          method: method,
          withCredentials: !!withCredentials,
          headers: (0, _extends3.default)({}, headers, customHeaders)
        };

        if (typeof url === "function") {
          requestConfig.url = url(state);
        } else {
          requestConfig.url = url;

          if (!!params) {
            if (typeof params !== "string" && (0, _lodash4.default)(params)) {
              params = (0, _utils.serialize)(params);
            }
            if (typeof params === "string") {
              requestConfig.url = (requestConfig.url + (requestConfig.url.indexOf("?") === -1 ? "?" : "&") + params).replace(/\?&/gi, "?");
            } else {
              requestConfig.params = params;
            }
          }
        }

        if (isPost) {
          if (!!postData && contentType.indexOf("x-www-form-urlencoded") !== -1 && (0, _lodash4.default)(postData)) {
            postData = (0, _utils.serialize)(postData);
          }
          requestConfig.data = postData;
        }

        if (!!responseType) {
          requestConfig.responseType = responseType;
        }

        _this.setState({ isLoading: true, error: null }, function () {
          return fetchCreator((0, _extends3.default)({}, requestConfig, axiosConfig)).then(function (response) {
            if (!_this._mounted) {
              return;
            }

            _this.setState({
              response: response,
              data: response.data,
              isLoading: false
            }, function () {
              if (!!onResponse) onResponse({
                isLoading: false,
                response: _this.state.response,
                data: _this.state.data,
                set: _this.setCustomState,
                params: params,
                postData: !!isPost ? postData : null,
                state: _this.state.customState,
                error: null
              });
            });
          }).catch(function (error) {
            if (!_this._mounted) {
              return;
            }

            var transformedError = transformError((0, _extends3.default)({}, error));

            _this.setState(function () {
              var errorState = {
                error: "" + (!!transformedError && typeof transformedError === "string" ? transformedError : error),
                response: null,
                data: null,
                isLoading: false
              };
              if (!!transformedError && (typeof transformedError === "undefined" ? "undefined" : (0, _typeof3.default)(transformedError)) === "object" && "response" in transformedError) {
                errorState.response = transformedError.response;

                if (!!errorState.response && (0, _typeof3.default)(errorState.response) === "object" && "data" in errorState.response) {
                  errorState.data = errorState.response.data;
                }
              }

              return errorState;
            }, function () {
              if (!!onError) onError(transformedError, {
                isLoading: false,
                response: _this.state.response,
                error: _this.state.error,
                data: _this.state.data,
                set: _this.setCustomState,
                params: params,
                postData: !!isPost ? postData : null,
                state: _this.state.customState
              });
            });
          });
        });
      };

      _this._mounted = false;


      _this._debouncedUpdate = +props.debounce > 0 ? (0, _lodash2.default)(_this._update.bind(_this), +props.debounce) : _this._update.bind(_this);

      _this.state = {
        isLoading: !!props.autoFetch,
        response: null,
        data: null,
        error: null,
        params: null,
        postData: null,
        customState: {}
      };
      return _this;
    }

    (0, _createClass3.default)(AsyncFetcher, [{
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps, prevState) {
        this._debouncedUpdate(prevProps, prevState);
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        this._mounted = true;

        if (!!this.props.autoFetch) {
          this.fetch();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this._mounted = false;
      }
    }, {
      key: "_update",
      value: function _update(prevProps, prevState) {
        var _this2 = this;

        var hasChange = false;
        ["method", "params", "postData", "url", "authToken"].forEach(function (k) {
          if (k in prevProps && !(0, _fastDeepEqual2.default)(prevProps[k], _this2.props[k])) {
            hasChange = true;
          }
        });
        if (!hasChange) {
          ["params", "postData"].forEach(function (k) {
            if (k in prevState && !(0, _fastDeepEqual2.default)(prevState[k], _this2.state[k])) {
              hasChange = true;
            }
          });
        }

        if (+prevProps.debounce !== +this.props.debounce) {
          this._debouncedUpdate = +this.props.debounce > 0 ? (0, _lodash2.default)(this._update.bind(this), +this.props.debounce) : this._update.bind(this);
        }

        if (hasChange && !!this.props.autoFetch) {
          this.fetch();
        }
      }
    }, {
      key: "render",
      value: function render() {
        if (!!this.props.children && typeof this.props.children === "function") {
          return this.props.children((0, _extends3.default)({
            fetch: this.fetch,
            isLoading: this.state.isLoading,
            response: this.state.response,
            data: this.state.data,
            error: this.state.error,
            set: this.setCustomState
          }, this.getState())) || null;
        }

        return null;
      }
    }]);
    return AsyncFetcher;
  }(_react.PureComponent);

  AsyncFetcher.propTypes = {
    autoFetch: _propTypes2.default.bool,
    autoPreventDefault: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),
    canFetch: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),
    method: _propTypes2.default.oneOf(["get", "post", "put", "delete", "options"]),
    url: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
    params: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
    postData: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
    headers: _propTypes2.default.object,
    axiosConfig: _propTypes2.default.object,
    ajax: _propTypes2.default.bool,
    authToken: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
    accepts: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array, _propTypes2.default.func]),
    contentType: _propTypes2.default.string,
    responseType: _propTypes2.default.string,
    withCredentials: _propTypes2.default.bool,
    transformError: _propTypes2.default.func,
    fetchCreator: _propTypes2.default.func,
    onResponse: _propTypes2.default.func,
    onError: _propTypes2.default.func,
    debounce: _propTypes2.default.number,
    children: _propTypes2.default.func
  };
  AsyncFetcher.defaultProps = {
    autoFetch: true,
    canFetch: true,
    autoPreventDefault: true,
    method: "get",
    headers: {},
    axiosConfig: {},
    ajax: false,
    withCredentials: false,
    transformError: function transformError(err) {
      return err;
    },
    fetchCreator: defaultFetchCreator,
    debounce: 0
  };
  exports.default = AsyncFetcher;
});