(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define("AsyncFetcher", ["exports", "babel-runtime/core-js/object/assign", "babel-runtime/helpers/typeof", "lodash.isplainobject"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("babel-runtime/core-js/object/assign"), require("babel-runtime/helpers/typeof"), require("lodash.isplainobject"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.assign, global._typeof, global.lodash);
    global.AsyncFetcher = mod.exports;
  }
})(this, function (exports, _assign, _typeof2, _lodash) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.isEvent = isEvent;
  exports.serialize = serialize;
  exports.concatParams = concatParams;
  exports.parseMime = parseMime;

  var _assign2 = _interopRequireDefault(_assign);

  var _typeof3 = _interopRequireDefault(_typeof2);

  var _lodash2 = _interopRequireDefault(_lodash);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function isEvent(e) {
    return (typeof e === "undefined" ? "undefined" : (0, _typeof3.default)(e)) === "object" && ("nativeEvent" in e && e.nativeEvent instanceof Event || "type" in e && !!e.type && "target" in e);
  }

  function serialize(obj) {
    var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    var str = [];
    for (var p in obj) {
      if (obj.hasOwnProperty(p)) {
        var k = prefix ? prefix + "[" + p + "]" : p,
            v = obj[p];
        str.push(v !== null && (typeof v === "undefined" ? "undefined" : (0, _typeof3.default)(v)) === "object" ? serialize(v, k) : encodeURIComponent(k) + "=" + encodeURIComponent(v));
      }
    }
    return str.join("&");
  }

  function concatParams(a, b) {
    if (!!a && !!b) {
      if ((0, _lodash2.default)(a) && (0, _lodash2.default)(b)) {
        return (0, _assign2.default)(a, b);
      }
      if ((0, _lodash2.default)(a) && typeof b === "string") {
        return (serialize(a) + "&" + b).replace(/&&/gi, "&");
      }
      if ((0, _lodash2.default)(b) && typeof a === "string") {
        return (a + "&" + serialize(b)).replace(/&&/gi, "&");
      }
      if (typeof a === "string" && typeof b === "string") {
        return (a + "&" + b).replace(/&&/gi, "&");
      }
    }

    return a || b || null;
  }

  function parseMime(type) {
    var charset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "utf-8";

    if (!!type && typeof type === "string" && type.indexOf("/") === -1) {
      switch (type.trim().toLowerCase()) {
        case "json":
          return "application/json";
        case "xml":
          return "application/xml";
        case "multipart":
          return "multipart/form-data";
        case "form":
          return "application/x-www-form-urlencoded; charset=" + charset;
        case "html":
          return "text/html";
        default:
          return "text/plain";
      }
    }

    return type;
  }
});